var unselectedColor = "#fff";
var highlightedColor = "#90c7eb";

var highlightedDiv = null;
var divToHighlight = null;

function Replace(content) {

    if(content.myBadges != "") {
        var myBadgesDiv = document.getElementById("mybadges");
        for(var child; child = myBadgesDiv.firstChild;) {
            myBadgesDiv.removeChild(child);
        }
        myBadgesDiv.innerHTML = content.myBadges;
    }

    var badgesDiv = document.getElementById("badges");
    for(var child; child = badgesDiv.firstChild;) {
        badgesDiv.removeChild(child);
    }
    badgesDiv.innerHTML = content.badges;
}

var badge_item_regex = /^badge-\d+/;
function getBadgeItem(el) {
    while (el != null) {
        if (badge_item_regex.test(el.id))
            return el;
        el = el.parentNode;
    }
    return null;
}

var my_badge_item_regex = /^mybadge-\d+/;
function getMyBadgeItem(el) {
    while (el != null) {
        if (my_badge_item_regex.test(el.id))
            return el;
        el = el.parentNode;
    }
    return null;
}


function HighlightDiv() {
    if(divToHighlight != null) {
        if(highlightedDiv != null) {
            highlightedDiv.style.background = unselectedColor;
        }
        highlightedDiv = divToHighlight;
        divToHighlight = null;
        highlightedDiv.style.background = highlightedColor;
    }
}

function UnHighlightDiv () {
    if(highlightedDiv != null) {
        highlightedDiv.style.background = unselectedColor;
        highlightedDiv = null;
    }
}

hammer.on("drag", function(event) {
    if(highlightedDiv != null) {
        highlightedDiv.style.background = unselectedColor;
        highlightedDiv = null;
    }
    if(divToHighlight != null) {
        divToHighlight = null;
    }
});

hammer.on("touch", function(event) {
    var badge_item = getBadgeItem(event.target);
    if (badge_item == null) {
        return;
    }

    divToHighlight = badge_item;
    window.setTimeout(HighlightDiv, 75);
});

hammer.on("release", function(event) {

    if(highlightedDiv != null) {
        highlightedDiv.style.background = unselectedColor;
        highlightedDiv = null;
        divToHighlight = null;
    }
    if(divToHighlight != null) {
        var badge_item = getBadgeItem(event.target);
        if(divToHighlight == badge_item) {
            HighlightDiv();
            window.setTimeout(UnHighlightDiv, 500);
        }
        divToHighlight = null;
    }
});

hammer.on("tap", function (event) {
    var badge_item = getBadgeItem(event.target);
    if (badge_item == null) {
        var mybadge_item = getMyBadgeItem(event.target);
        if(mybadge_item != null) {
            var badge_type = mybadge_item.getAttribute("data-badge-type");
            ddx.send("MyBadgeSelected", badge_type);
        }

        return;
    }
    var badge_type = badge_item.getAttribute("data-badge-type");

    ddx.send("BadgeSelected", badge_type);
});

function SlidingStateChanged() {}