//received(type, js_object)
//instanceToken
var ddx = {
    webApiVersion:1,
    //called by native webview to tell it to push messages
    pullFromNative: function() {
        for (;;) {
            var packed = window.prompt("ddx:pull:" + ddx.instanceToken);
            if (typeof packed != "string")
                break;
            //ddx.log(packed);
            var split = packed.split(':', 2);
            if (split.length != 2) {
                ddx.log("invalid format for ddx " + packed);
                continue;
            }
            var rest = packed.substring(split[0].length + split[1].length + 2);
            if (rest.length <= 0 || rest == "undefined" || rest == "null") {
                ddx.received(split[1], undefined);
            } else {
                ddx.received(split[1], JSON.parse(rest));
            }
        }
    },
    
    // async response
    pendingCallbacks: {},
    lastCallbackId: 0,
    
    //called by html to push a message (same on all platforms)
    send: function(type, object, successCallback, failCallback) {
        var data;
        if (arguments.length > 2) {
            var token = ++this.lastCallbackId;
            this.pendingCallbacks[token] = [ successCallback, failCallback ];
            data = JSON.stringify({ Token:token, Arg:JSON.stringify(object) });
        } else {
            data = JSON.stringify(object);
        }
        var packed = "ddx:push:" + ddx.instanceToken + ":" + type + ":" + data;
        //ddx.log("sending: " + packed);
        window.prompt(packed);
    },
    received: function(type, arg) {
        var handler = window[type];
        if (typeof handler != "function") {
            ddx.log("missing event handler in web view for " + type);
            return;
        }
        handler(arg);
    },
    log: function(message) {
        console.log(message);
    },
    ready: function() {
        ddx.send("PostLayout");
        ddx.pullFromNative();
    }
};

function Ddx_CompleteRequest(response) {
    // response.Token, response.Arg, response.Success
    var callbacks = ddx.pendingCallbacks[response.Token];
    delete ddx.pendingCallbacks[response.Token];

    if (!Array.isArray(callbacks)) {
      ddx.log("Callback does not exist for token " + response.Token);
      return;
    }
    if (response.Success) {
      if (typeof callbacks[0] != 'function') {
        ddx.log("Missing success callback");
      } else {
        callbacks[0](response.Arg);
      }
    } else {
      if (typeof callbacks[1] != 'function') {
        ddx.log("Missing failure callback");
      } else {
        callbacks[1](response.Arg);
      }
    }
}