﻿//received(type, js_object)
//instanceToken
var ddx = {
    webApiVersion:1,
    msgs: [],
    //called by native webview to get any queued messages;
    pullToNative: function () {
        if (this.msgs.length == 0)
            return null;
        var msg = this.msgs.shift();
        return ddx.instanceToken + ":" + msg.type + ":" + msg.object;
    },

    // async response
    pendingCallbacks: {},
    lastCallbackId: 0,

    //called by html to push a message (same on all platforms)
    send: function (type, object) {
        var data;
        if (arguments.length > 2) {
            var token = ++this.lastCallbackId;
            this.pendingCallbacks[token] = [successCallback, failCallback];
            data = JSON.stringify({ Token: token, Arg: JSON.stringify(object) });
        } else {
            data = JSON.stringify(object);
        }

        var msg = {};
        msg.token = ddx.instanceToken;
        msg.type = type;
        msg.object = data;
        this.msgs.push(msg);
        window.location = "ddx:pull";
    },
    received: function (instanceId, type, arg) {
        var handler = window[type];
        if (typeof handler != "function") {
            ddx.log("missing event handler in web view for " + type);
            return;
        }
        handler(arg);
    },
    log: function (message) {
        ddx.send("Log", message);
    },
    ready: function () {
        ddx.send("PostLayout");
        window.location = "ddx:pull";
    }
};

function Ddx_CompleteRequest(response) {
    // response.Token, response.Arg, response.Success
    var callbacks = ddx.pendingCallbacks[response.Token];
    delete ddx.pendingCallbacks[response.Token];

    if (!Array.isArray(callbacks)) {
        ddx.log("Callback does not exist for token " + response.Token);
        return;
    }
    if (response.Success) {
        if (typeof callbacks[0] != 'function') {
            ddx.log("Missing success callback");
        } else {
            callbacks[0](response.Arg);
        }
    } else {
        if (typeof callbacks[1] != 'function') {
            ddx.log("Missing failure callback");
        } else {
            callbacks[1](response.Arg);
        }
    }
}