//nativeDdx.push(token, type, jsonData)
//nativeDdx.pull() => token:type:jsonData
var ddx = {
    webApiVersion:1,
    //called by native webview to tell it to push messages
    pullFromNative: function() {
    	var xhr = new XMLHttpRequest();
		xhr.onreadystatechange=function()
		{
			if (xhr.readyState==4 && xhr.status==200)
			{
	            var packed = xhr.responseText;
	            if (typeof packed != "string") {
	                alert("pull pre format failure");
	                return;
                }
	            //ddx.log(packed);
	            var split = packed.split(':', 2);
	            if (split.length != 2) {
	                ddx.log("invalid format for ddx " + packed);
	                alert("pull format failure");
	                return;
	            }
	            var rest = packed.substring(split[0].length + split[1].length + 2);
			    try {
			        if (rest.length <= 0 || rest == "undefined" || rest == "null") {
			            ddx.received(split[1], undefined);
			        } else {
			            ddx.received(split[1], JSON.parse(rest));
			        }
			    } catch(e)
			    {
			    }
			    ddx.pullFromNative();
	            return;
			}
			if (xhr.readyState==4 && xhr.status != 200) {
				window.setTimeout(ddx.pullFromNative, 30);
			}
		};
		xhr.open("GET", "http://127.0.0.1:2020/Screen/Pull/" + ddx.instanceToken, true);
    	xhr.send();
    },
    
        
    // async response
    pendingCallbacks: {},
    lastCallbackId: 0,

    //called by html to push a message (same on all platforms)
    // successCallback and failCallback are for DDX methods supporting a callback.
    send: function(type, object, successCallback, failCallback) {
        var data;
        if (arguments.length > 2) {
            var token = ++this.lastCallbackId;
            this.pendingCallbacks[token] = [ successCallback, failCallback ];
            data = JSON.stringify({ Token:token, Arg:JSON.stringify(object) });
        } else {
            data = JSON.stringify(object);
        }
    	var xhr = new XMLHttpRequest();
		xhr.onreadystatechange=function()
		{

			if (xhr.readyState==4 && xhr.status != 204) {
                //alert("Failed push " + xhr.status + "\n" + xhr.responseText);
			}
		};
		xhr.open("PUT", "http://127.0.0.1:2020/Screen/Push", true);
		xhr.send(JSON.stringify(ddx.instanceToken + ":" + type + ":" + data));
    },
    received: function(type, arg) {
        var handler = window[type];
        if (typeof handler != "function") {
            ddx.log("missing event handler in web view for " + type);
            return;
        }
        handler(arg);
    },
    log: function(message) {
        console.log(message);
    },
    ready: function () {
      ddx.send("PostLayout");
      ddx.pullFromNative();
    }
};

function Ddx_CompleteRequest(response) {
    // response.Token, response.Arg, response.Success
    var callbacks = ddx.pendingCallbacks[response.Token];
    delete ddx.pendingCallbacks[response.Token];

    if (!Array.isArray(callbacks)) {
      ddx.log("Callback does not exist for token " + response.Token);
      return;
    }
    if (response.Success) {
      if (typeof callbacks[0] != 'function') {
        ddx.log("Missing success callback");
      } else {
        callbacks[0](response.Arg);
      }
    } else {
      if (typeof callbacks[1] != 'function') {
        ddx.log("Missing failure callback");
      } else {
        callbacks[1](response.Arg);
      }
    }
}