function PostLayout() {
    ddx.send("UpdateLibraryImages");
}

function LoadProducts(generatedHtml) {
    document.body.style.backgroundColor = "#f4f4f4";

    document.getElementById("products").innerHTML = generatedHtml;
}

function PurchaseProduct(productId) {
    ddx.send("PurchaseProduct", productId);
}

function PreviewProduct(productId) {
    ddx.send("PreviewProduct", productId);
}

function SetLoadingIndicatorForButton(index)
{
    var button = document.getElementById("buy-button-" + index);
    button.className="buy-button-busy";
}

function SetProgress(args)
{
    var Index = args.Index;
    var ProgressPercent = args.ProgressPercent;
    
    var outline = document.getElementById("progress-bar-outline-" + Index);
    outline.style.visibility = "visible";
    
    var progress = document.getElementById("progress-bar-" + Index);
    progress.style.width = ProgressPercent+"%";
}

var highlightedDiv = null;
var highlightedButton = null;
var unselectedColor = "#fff";
var highlightedColor = "#89e6fc";

hammer.on("touch", function (event) {
    var touchable = getTouchable(event.target);
    if(touchable == null) {
        highlightedDiv = null;
        highlightedButton = null;
        return true;
    }
    if(touchable.className == "item") {
        highlightedDiv = touchable;
        unselectedColor = highlightedDiv.style.backgroundColor;
        highlightedDiv.style.backgroundColor = highlightedColor;
    }
    else if(touchable.className == "buy-button") {
        highlightedButton = touchable;
        highlightedButton.className = "buy-button-active";
    }
    return true;
    
});
hammer.on("release", function (event) {
    if (highlightedDiv != null) {
        highlightedDiv.style.backgroundColor = unselectedColor;
        highlightedDiv = null;
    }
    if(highlightedButton != null) {
        highlightedButton.className = "buy-button";
        highlightedButton = null;
    }
    return true;
});

hammer.on("tap", function (event) {
    var touchable = getTouchable(event.target);
    if (touchable == null)
        return true;

    var parts = touchable.getAttribute("data-touchable").split(':');
    if (parts[0] == "purchase") {
        PurchaseProduct(parts[1]);
        return false;
    }
    if (parts[0] == "preview") {
        PreviewProduct(parts[1]);
        return false;
    }
    
    return true;
});